(* Storing process variables values *)
type t

val init: unit -> t

(** [set env process_id var_name var_value] *)
val set: t -> string -> string -> Algo.value -> t

(** [get env process_id var_name] *)
val get: t -> string -> string -> Algo.value

(** In order to make sure that arrays ref are not shared between processes,
    this function performs an array copy of the value (if it is an array) 
 *)
val get_copy: t -> string -> string -> Algo.value

